%{ 
  open Gui
  open User
%}
%token <string> VAR
%token <string> LVAR
%token LPAREN
%token RPAREN
%token ARROW
%token EOI

/*優先順位と連結性をここに書く(下に行くほど強くなる)*/
%right ARROW

/*開始記号の定義*/
%type <User.Term.fix_t> start
%type <User.Term.fix_t> terms
%start start terms

%%

start:
| term EOI                      {$1}

terms:
| term EOI                      {$1}

term:
| LVAR                          {Term.make_meta ($1)}
| VAR                           {term_var (var $1)}
| term ARROW term               {term_arrow $1 $3}
| LPAREN term RPAREN            {$2}
